# Hiker

# Returns if the passed url matches the scheme-template
exports.urlMatchesScheme = (url, schemeTemplate) ->
  url = url.replace(/\?.*$/, '')

  return yes if url == schemeTemplate

  result = if new RegExp("^" + schemeTemplate.replace(/:(\w|_)+/g, "([^\/]+)") + '(\\.(\\w+))*$').test(url)
    yes
  else
    no

  return result

# Parses and matches url with the scheme-template
exports.build = (url, schemeTemplate) ->
  urlParts = url.split('?')[0].split('/')
  params = url.split('?')[1]

  scheme = parseURLParams({}, params)
  schemeTemplateParts = schemeTemplate.split('/')

  matcher = new RegExp(/:(\w|_)+/)
  for i in [0...schemeTemplateParts.length] by 1
    if matcher.test(schemeTemplateParts[i])

      # assign the url part to the schemeTemplatePart (remove leading :) => "id => 'param'"
      scheme[schemeTemplateParts[i][1...schemeTemplateParts[i].length]] = urlParts[i]

  return scheme


# Parse URL params (?foo=bar)
parseURLParams = (scheme, params) ->
  if params? && params = params.split('&')
    for param in params
      value = param.split('=')[1]
      scheme[param.split('=')[0]] = value || ""

  scheme
